#!/bin/bash
# ------------------------------------------------------------------------
# Trie les images d'un dossier (unique avec que des images)
# selon la taille de celle ci
# crée le dossier selon la largeur si celui ci n'existe pas
# copie (ou déplace) l'image dans le répertoire avec la même largeur
# ------------------------------------------------------------------------
# 20240224 - R. Suinot
# V0.0 creation 
# ------------------------------------------------------------------------
#set -xe

IDENTIFY="/usr/bin/identify"
Nombre_arguments_attendus=1
#rep_images="$HOME/Images/wallpapers/"
#liste_images="$rep_images*"

# ------------------------------------------------------------------------
# Début des functions
# ------------------------------------------------------------------------
function taille_image {
	fichier=$1

	if [ ! -L $fichier ];
	then
		# ce n'est pas un lien symbolique on continu
		# on identify l'image et on récupère uniquement la largeur
		largeur=`$IDENTIFY -format '%w' $fichier`

		# on appel creation_repertoire pour savoir si le répertoire à cette taille existe
		creation_repertoire $largeur
		new_rep=$rep_images$largeur
		# on copie/déplace l'image dans le répertoire
		cp $fichier $new_rep
	fi
}

function creation_repertoire {
# si le répertoire n'existe pas, on le crée
	rep_taille=$rep_images$1
	if [ ! -d $rep_taille ];
	then
		mkdir $rep_taille
	fi
}
# ------------------------------------------------------------------------
# Fin des functions
# ------------------------------------------------------------------------

# $IDENTIFY $liste_images
# for fic in $IDENTIFY $liste_images;

if [ $# -ne $Nombre_arguments_attendus ]; then
	echo "Le nombre d'arguments est invalide : $#"
	echo "Nombre argument attendu  :  ${Nombre_arguments_attendus} "
	exit 1
else
        if [ -d $1 ];
        then
                rep_images=$1
                liste_images="$rep_images*"
        else
                echo "erreur sur le répertorie d'images"
                exit 1
        fi
fi

cd $rep_images
for fic in ./* ;
do
       	echo "$fic"
	if [ -f $fic ];
	then
		taille_image $fic
	else
		echo "|"
		echo "+------- C'est un répertoire, on passe."
	fi
done
